#include"../../Maid/template/Mathematics.h"


using namespace Maid;

void main()
{
	{	//	POINT テスト
		POINT2DI pos0(10,10);
		POINT2DI pos1;
		
		pos1 = -pos0;
		if( pos1==pos0 ) { }
		if( pos1!=pos0 ) { }
	}

	{	//	VECTOR テスト
		VECTOR2DI vec0(10,-10);
		VECTOR2DI vec1(POINT2DI(0,0),POINT2DI(5,5));

		VECTOR2DI vec2 = vec0 + vec1;

		vec0 += vec1;
		vec0 -= vec1;
		vec0 *= 10;
		vec0 /= 5;
	}

	{	//	Matrix テスト

		MATRIX4DI mat1( MATRIX4DI().SetIdentity() );
		MATRIX4DI mat2( MATRIX4DI().SetScale(5) );

		MATRIX4DI mat3 = mat1 * mat2;
		
		mat3 *= mat2;

	}

	{	//	異なる型の演算

		VECTOR2DI vec0(10,-10);
		POINT2DI pos0(0,0);

		pos0 = pos0 + vec0;

		pos0 += vec0;
	}

}